use proc_macro::TokenStream;
use quote::quote;
use syn;

#[proc_macro_derive(HelloMacro)]
pub fn hello_macro_derive(input: TokenStream) -> TokenStream {
    // Konstruuje reprezentację kodu Rusta jako drzewa składni,
    // którą możemy manipulować
    let ast = syn::parse(input).unwrap();

    // Buduje implementację cechy
    impl_hello_macro(&ast)
}

fn impl_hello_macro(ast: &syn::DeriveInput) -> TokenStream {
    let name = &ast.ident;
    let gen = quote! {
        impl HelloMacro for #name {
            fn hello_macro() {
                println!("Witaj, Makro! Nazywam się {}!", stringify!(#name));
            }
        }
    };
    gen.into()
}
